<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>e-combox documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">e-combox documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li >ApiService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/ecombox/shared/api/api.service.ts</code>
        </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#basePath" >basePath</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#configuration" >configuration</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#defaultHeaders" >defaultHeaders</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Protected</span>
                                <a href="#canConsumeForm" >canConsumeForm</a>
                            </li>
                            <li>
                                    <span class="modifier">Protected</span>
                                <a href="#configureDefaultHeaders" >configureDefaultHeaders</a>
                            </li>
                            <li>
                                    <span class="modifier">Protected</span>
                                <a href="#handleError" >handleError</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(httpClient: <a href="https://angular.io/api/common/http/HttpClient" target="_blank">HttpClient</a>, basePath?: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, configuration?: <a href="../classes/Configuration.html" target="_self">Configuration</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="11" class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:11</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                                    <td>Description</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>httpClient</td>
                                                  
                                                        <td>
                                                                        <code><a href="https://angular.io/api/common/http/HttpClient" target="_blank" >HttpClient</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                        <td>
                                                        </td>
                                                </tr>
                                                <tr>
                                                        <td>basePath</td>
                                                  
                                                        <td>
                                                                        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            Yes
                                                    </td>
                                                    
                                                        <td>
                                                                <p>Optional</p>

                                                        </td>
                                                </tr>
                                                <tr>
                                                        <td>configuration</td>
                                                  
                                                        <td>
                                                                        <code><a href="../classes/Configuration.html" target="_self" >Configuration</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            Yes
                                                    </td>
                                                    
                                                        <td>
                                                                <p>Optional</p>

                                                        </td>
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="canConsumeForm"></a>
                    <span class="name">
                        <span class="modifier">Protected</span>
                        <span ><b>canConsumeForm</b></span>
                        <a href="#canConsumeForm"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>canConsumeForm(consumes: string[])</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="37"
                            class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:37</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Description</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>consumes</td>
                                    <td>
                                            <code>string[]</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                    <td>
                                        <p>mime-types</p>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                    </div>
                    <div class="io-description">
                        <p>true: consumes contains &#39;multipart/form-data&#39;, false: otherwise</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="configureDefaultHeaders"></a>
                    <span class="name">
                        <span class="modifier">Protected</span>
                        <span ><b>configureDefaultHeaders</b></span>
                        <a href="#configureDefaultHeaders"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>configureDefaultHeaders()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="51"
                            class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:51</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Configure headers request</p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://angular.io/api/common/http/HttpHeaders" target="_blank" >HttpHeaders</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="handleError"></a>
                    <span class="name">
                        <span class="modifier">Protected</span>
                        <span ><b>handleError</b></span>
                        <a href="#handleError"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>handleError(operation: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, result?: T)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="89"
                            class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:89</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>T</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Handle errors request</p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>operation</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&quot;operation&quot;</code>
                                    </td>

                                </tr>
                                <tr>
                                    <td>result</td>
                                    <td>
                                            <code>T</code>
                                    </td>

                                    <td>
                                        Yes
                                    </td>

                                    <td>
                                    </td>

                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>(error: any) &#x3D;&gt; Observable&lt;T&gt;</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section>
    
    <h3 id="inputs">
        Properties
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="basePath"></a>
                    <span class="name">
                            <span class="modifier">Public</span>
                        <span ><b>basePath</b></span>
                        <a href="#basePath"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>&quot;http://cub.corsica:8880/portainer/api&quot;</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="9" class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:9</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="configuration"></a>
                    <span class="name">
                            <span class="modifier">Public</span>
                        <span ><b>configuration</b></span>
                        <a href="#configuration"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>new Configuration()</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="11" class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:11</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="defaultHeaders"></a>
                    <span class="name">
                            <span class="modifier">Public</span>
                        <span ><b>defaultHeaders</b></span>
                        <a href="#defaultHeaders"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>new HttpHeaders()</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="10" class="link-to-prism">src/app/ecombox/shared/api/api.service.ts:10</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Optional, Inject, Injectable } from &quot;@angular/core&quot;;
import { HttpHeaders, HttpClient } from &quot;@angular/common/http&quot;;
import { Configuration } from &quot;./configuration&quot;;
import { BASE_PATH } from &quot;./variables&quot;;
import { Observable, of } from &quot;rxjs&quot;;

@Injectable()
export class ApiService {
  public basePath &#x3D; &quot;http://cub.corsica:8880/portainer/api&quot;;
  public defaultHeaders &#x3D; new HttpHeaders();
  public configuration &#x3D; new Configuration();

  /**
   *
   * @param {HttpClient} httpClient
   * @param {string} basePath Optional
   * @param {Configuration} configuration Optional
   */
  constructor(
    protected httpClient: HttpClient,
    @Optional() @Inject(BASE_PATH) basePath?: string,
    @Optional() configuration?: Configuration
  ) {
    if (basePath) {
      this.basePath &#x3D; basePath;
    }
    if (configuration) {
      this.configuration &#x3D; configuration;
      this.basePath &#x3D; basePath || configuration.basePath || this.basePath;
    }
  }

  /**
   * @param {string[]} consumes  mime-types
   * @return {boolean} true: consumes contains &#x27;multipart/form-data&#x27;, false: otherwise
   */
  protected canConsumeForm(consumes: string[]): boolean {
    const form &#x3D; &quot;multipart/form-data&quot;;
    for (const consume of consumes) {
      if (form &#x3D;&#x3D;&#x3D; consume) {
        return true;
      }
    }
    return false;
  }

  /**
   * Configure headers request
   * @return {HttpHeaders}
   */
  protected configureDefaultHeaders(): HttpHeaders {
    let headers &#x3D; this.defaultHeaders;

    const httpHeaderAccepts: string[] &#x3D; [
      &quot;application/json&quot;,
      &quot;text/html&quot;,
      &quot;application/xhtml+xml&quot;,
      &quot;application/vnd.docker.distribution.manifest.v2+json&quot;,
      &quot;*/*&quot;,
    ];
    const httpHeaderAcceptSelected:
      | string
      | undefined &#x3D; this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected !&#x3D;&#x3D; undefined) {
      headers &#x3D; headers.set(&quot;Accept&quot;, httpHeaderAcceptSelected);
    }

    const consumes: string[] &#x3D; [
      &quot;application/json&quot;,
      &quot;charset&#x3D;utf-8&quot;,
      &quot;application/x-www-form-urlencoded&quot;,
    ];
    const httpContentTypeSelected:
      | string
      | undefined &#x3D; this.configuration.selectHeaderContentType(consumes);
    if (httpContentTypeSelected !&#x3D;&#x3D; undefined) {
      headers &#x3D; headers.set(&quot;Content-Type&quot;, httpContentTypeSelected);
    }

    return headers;
  }

  /**
   * Handle errors request
   * @param {string} operation
   * @param {T} result
   * @return {Observable}
   */
  protected handleError&lt;T&gt;(operation &#x3D; &quot;operation&quot;, result?: T) {
    return (error): Observable&lt;T&gt; &#x3D;&gt; {
      // TODO: send the error to remote logging infrastructure
      console.error(error); // log to console instead

      // TODO: better job of transforming error for user consumption
      console.error(&#x60;${operation} failed: ${error.message}&#x60;);
      // Let the app keep running by returning an empty result.
      return of(result as T);
    };
  }
}
</code></pre>
    </div>

</div>












                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'ApiService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
